package com.me.brickbuster.entity;

import com.badlogic.gdx.graphics.g2d.SpriteBatch;
import com.badlogic.gdx.graphics.glutils.ShapeRenderer;
import com.badlogic.gdx.math.Vector2;
import com.me.brickbuster.state.FieldState;

public abstract class Entity {

	protected FieldState state;
	protected Vector2 pos;
	protected boolean deleted = false;

	public Entity(FieldState state, Vector2 pos) {
		this(state, pos.x, pos.y);
	}

	public Entity(FieldState state, float x, float y) {
		this.state = state;
		this.pos = new Vector2(x, y);
	}

	public abstract void render(SpriteBatch sb, ShapeRenderer sr);

	public abstract void update(float dt);

	public void dispose() {}

	public Vector2 getPos() {
		return pos;
	}

	public void setPos(Vector2 pos) {
		this.pos.set(pos);
	}

	public float getX() {
		return pos.x;
	}

	public void setX(float x) {
		pos.x = x;
	}

	public float getY() {
		return pos.y;
	}

	public void setY(float y) {
		pos.y = y;
	}

	public void delete() {
		this.deleted = true;
	}

	public boolean isDeleted() {
		return deleted;
	}

}
