package com.me.brickbuster.state;

import com.badlogic.gdx.graphics.g2d.TextureAtlas;
import com.badlogic.gdx.physics.box2d.World;
import com.me.brickbuster.BrickBuster;

public abstract class FieldState extends State {

	public World world;
	public TextureAtlas textures;

	public FieldState(BrickBuster game) {
		super(game);
	}

	@Override
	public void setup() {
		game.assets.load("textures.atlas", TextureAtlas.class);
		game.assets.finishLoading();

		textures = game.assets.get("textures.atlas", TextureAtlas.class);
	}

	@Override
	public void dispose() {
		super.dispose();
		textures.dispose();
	}

}
